Index: /trunk/src/kmk/Makefile.am
===================================================================
--- /trunk/src/kmk/Makefile.am	(revision 1339)
+++ /trunk/src/kmk/Makefile.am	(revision 1340)
@@ -33,5 +33,5 @@
 SUBDIRS =	glob config $(MAYBE_W32)
 
-bin_PROGRAMS =	kmk
+bin_PROGRAMS =	kmk kmk_redirect
 
 if USE_CUSTOMS
@@ -49,6 +49,6 @@
 		kbuild.c \
 		electric.c \
-        ../lib/md5.c \
-        ../lib/kDep.c \
+		../lib/md5.c \
+		../lib/kDep.c \
 		\
 		kmkbuiltin.c \
@@ -69,4 +69,5 @@
 		kmkbuiltin/rm.c \
 		kmkbuiltin/rmdir.c \
+		kmkbuiltin/test.c \
 		kmkbuiltin/err.c \
 		kmkbuiltin/setmode.c \
@@ -74,7 +75,7 @@
 		kmkbuiltin/strlcpy.c \
 		kmkbuiltin/osdep.c \
-		kmkbuiltin/version.c
-
-## TODO kmk_redirect.
+		kmkbuiltin/kbuild_version.c
+
+kmk_redirect_SOURCES = kmkbuiltin/redirect.c
 
 EXTRA_kmk_SOURCES = vmsjobs.c remote-stub.c remote-cstms.c
@@ -135,5 +136,5 @@
     @DEFS@
 
-AM_CPPFLAGS =	$(GLOBINC)
+AM_CPPFLAGS =	$(GLOBINC) -I$(srcdir)/../lib
 # Only process if target is MS-Windows
 if WINDOWSENV
Index: /trunk/src/kmk/Makefile.kmk
===================================================================
--- /trunk/src/kmk/Makefile.kmk	(revision 1339)
+++ /trunk/src/kmk/Makefile.kmk	(revision 1340)
@@ -50,5 +50,5 @@
 	kmkbuiltin/setmode.c \
 	kmkbuiltin/strmode.c \
-	kmkbuiltin/version.c \
+	kmkbuiltin/kbuild_version.c \
 	getopt.c \
 	getopt1.c \
Index: /trunk/src/kmk/kmkbuiltin/kbuild_version.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/kbuild_version.c	(revision 1340)
+++ /trunk/src/kmk/kmkbuiltin/kbuild_version.c	(revision 1340)
@@ -0,0 +1,55 @@
+/* $Id$ */
+/** @file
+ * kbuild_version(), helper function.
+ */
+
+/*
+ * Copyright (c) 2007 knut st. osmundsen <bird-src-spam@anduin.net>
+ *
+ * This file is part of kBuild.
+ *
+ * kBuild is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * kBuild is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with kBuild; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+ *
+ */
+
+#include "kmkbuiltin.h"
+#include <string.h>
+#include <stdio.h>
+
+/**
+ * Prints the kBuild version message and returns 0.
+ *
+ * @returns 0
+ * @param   argv0       The argv0.
+ */
+int kbuild_version(const char *argv0)
+{
+    const char *tmp;
+
+    /* skip the path */
+    for (tmp = strpbrk(argv0, "\\/:"); tmp; tmp = strpbrk(argv0, "\\/:"))
+        argv0 = tmp + 1;
+
+    /* find the end, ignoring extenions */
+    tmp = strrchr(argv0, '.');
+    if (!tmp)
+        tmp = strchr(argv0, '\0');
+
+    printf("%.*s - kBuild version %d.%d.%d\n",
+           tmp - argv0, argv0,
+           KBUILD_VERSION_MAJOR, KBUILD_VERSION_MINOR, KBUILD_VERSION_PATCH);
+    return 0;
+}
+
Index: unk/src/kmk/kmkbuiltin/version.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/version.c	(revision 1339)
+++ 	(revision )
@@ -1,55 +1,0 @@
-/* $Id$ */
-/** @file
- * kbuild_version(), helper function.
- */
-
-/*
- * Copyright (c) 2007 knut st. osmundsen <bird-src-spam@anduin.net>
- *
- * This file is part of kBuild.
- *
- * kBuild is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * kBuild is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with kBuild; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
- *
- */
-
-#include "kmkbuiltin.h"
-#include <string.h>
-#include <stdio.h>
-
-/**
- * Prints the kBuild version message and returns 0.
- *
- * @returns 0
- * @param   argv0       The argv0.
- */
-int kbuild_version(const char *argv0)
-{
-    const char *tmp;
-
-    /* skip the path */
-    for (tmp = strpbrk(argv0, "\\/:"); tmp; tmp = strpbrk(argv0, "\\/:"))
-        argv0 = tmp + 1;
-
-    /* find the end, ignoring extenions */
-    tmp = strrchr(argv0, '.');
-    if (!tmp)
-        tmp = strchr(argv0, '\0');
-
-    printf("%.*s - kBuild version %d.%d.%d\n",
-           tmp - argv0, argv0,
-           KBUILD_VERSION_MAJOR, KBUILD_VERSION_MINOR, KBUILD_VERSION_PATCH);
-    return 0;
-}
-