Index: trunk/kBuild/tools/VCC70.kmk
===================================================================
--- trunk/kBuild/tools/VCC70.kmk	(revision 1349)
+++ trunk/kBuild/tools/VCC70.kmk	(revision 1350)
@@ -308,10 +308,5 @@
 		$(subst /,\\,$(libs))
 ifeq ($(filter %.exp .def,$(othersrc)),)
-ifdef KMK_NEW_CP
 	$(QUIET)$(CP) --changed --ignore-non-existing $(outbase).exp $(outbase).lib $(PATH_LIB)/
-else
-	$(QUIET)if test -f $(outbase).exp; then $(CP_EXT) $(outbase).exp $(PATH_LIB)/; fi
-	$(QUIET)if test -f $(outbase).lib; then $(CP_EXT) $(outbase).lib $(PATH_LIB)/; fi
-endif
 endif
 $(eval _DIRS += $(PATH_LIB))
Index: trunk/kBuild/tools/VCC80.kmk
===================================================================
--- trunk/kBuild/tools/VCC80.kmk	(revision 1349)
+++ trunk/kBuild/tools/VCC80.kmk	(revision 1350)
@@ -264,12 +264,6 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
-ifdef KMK_USE_TEST
 	$(QUIET)$(TEST) -f $(out).manifest -- \
 		$(TOOL_VCC80_MT) -manifest $(subst /,\\,$(out)).manifest -outputresource:$(subst /,\\,$(out))
-else
-	$(QUIET)if test -f $(out).manifest; then \
-		$(TOOL_VCC80_MT) -manifest $(subst /,\\,$(out)).manifest -outputresource:$(subst /,\\,$(out)); \
-	fi
-endif
 endef
 
@@ -305,19 +299,8 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
-ifdef KMK_USE_TEST
 	$(QUIET)$(TEST) -f $(out).manifest -- \
 		$(TOOL_VCC80_MT) -manifest $(subst /,\\,$(out)).manifest '-outputresource:$(subst /,\\,$(out));#2'
-else
-	$(QUIET)if test -f $(out).manifest; then \
-		$(TOOL_VCC80_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"; \
-	fi
-endif
 ifeq ($(filter %.exp .def,$(othersrc)),)
-ifdef KMK_NEW_CP
 	$(QUIET)$(CP) --changed --ignore-non-existing $(outbase).exp $(outbase).lib $(PATH_LIB)/
-else
-	$(QUIET)if test -f $(outbase).exp; then $(CP_EXT) $(outbase).exp $(PATH_LIB)/; fi
-	$(QUIET)if test -f $(outbase).lib; then $(CP_EXT) $(outbase).lib $(PATH_LIB)/; fi
-endif
 endif
 $(eval _DIRS += $(PATH_LIB))
@@ -353,12 +336,6 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
-ifdef KMK_USE_TEST
 	$(QUIET)$(TEST) -f $(out).manifest -- \
 		$(TOOL_VCC80_MT) -manifest $(subst /,\\,$(out)).manifest '-outputresource:$(subst /,\\,$(out));#2'
-else
-	$(QUIET)if test -f $(out).manifest; then \
-		$(TOOL_VCC80_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"; \
-	fi
-endif
-endef
-
+endef
+
Index: trunk/kBuild/tools/VCC80AMD64.kmk
===================================================================
--- trunk/kBuild/tools/VCC80AMD64.kmk	(revision 1349)
+++ trunk/kBuild/tools/VCC80AMD64.kmk	(revision 1350)
@@ -282,19 +282,8 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
-ifdef KMK_USE_TEST
 	$(QUIET)$(TEST) -f $(out).manifest -- \
 		$(TOOL_VCC80AMD64_MT) -manifest $(subst /,\\,$(out)).manifest '-outputresource:$(subst /,\\,$(out));#2'
-else
-	$(QUIET)if test -f $(out).manifest; then \
-		$(TOOL_VCC80AMD64_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"; \
-	fi
-endif
 ifeq ($(filter %.exp .def,$(othersrc)),)
-ifdef KMK_NEW_CP
 	$(QUIET)$(CP) --changed --ignore-non-existing $(outbase).exp $(outbase).lib $(PATH_LIB)/
-else
-	$(QUIET)if test -f $(outbase).exp; then $(CP_EXT) $(outbase).exp $(PATH_LIB)/; fi
-	$(QUIET)if test -f $(outbase).lib; then $(CP_EXT) $(outbase).lib $(PATH_LIB)/; fi
-endif
 endif
 $(eval _DIRS += $(PATH_LIB))
@@ -330,12 +319,6 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
-ifdef KMK_USE_TEST
 	$(QUIET)$(TEST) -f $(out).manifest -- \
 		$(TOOL_VCC80AMD64_MT) -manifest $(subst /,\\,$(out)).manifest '-outputresource:$(subst /,\\,$(out));#2'
-else
-	$(QUIET)if test -f $(out).manifest; then \
-		$(TOOL_VCC80AMD64_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"; \
-	fi
-endif
-endef
-
+endef
+
Index: trunk/kBuild/tools/VCC80X86.kmk
===================================================================
--- trunk/kBuild/tools/VCC80X86.kmk	(revision 1349)
+++ trunk/kBuild/tools/VCC80X86.kmk	(revision 1350)
@@ -243,12 +243,6 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
-ifdef KMK_USE_TEST
 	$(QUIET)$(TEST) -f $(out).manifest -- \
 		$(TOOL_VCC80X86_MT) -manifest $(subst /,\\,$(out)).manifest -outputresource:$(subst /,\\,$(out))
-else
-	$(QUIET)if test -f $(out).manifest; then \
-		$(TOOL_VCC80X86_MT) -manifest $(subst /,\\,$(out)).manifest -outputresource:$(subst /,\\,$(out)); \
-	fi
-endif
 endef
 
@@ -284,19 +278,8 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
-ifdef KMK_USE_TEST
 	$(QUIET)$(TEST) -f $(out).manifest -- \
 		$(TOOL_VCC80X86_MT) -manifest $(subst /,\\,$(out)).manifest '-outputresource:$(subst /,\\,$(out));#2'
-else
-	$(QUIET)if test -f $(out).manifest; then \
-		$(TOOL_VCC80X86_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"; \
-	fi
-endif
 ifeq ($(filter %.exp .def,$(othersrc)),)
-ifdef KMK_NEW_CP
 	$(QUIET)$(CP) --changed --ignore-non-existing $(outbase).exp $(outbase).lib $(PATH_LIB)/
-else
-	$(QUIET)if test -f $(outbase).exp; then $(CP_EXT) $(outbase).exp $(PATH_LIB)/; fi
-	$(QUIET)if test -f $(outbase).lib; then $(CP_EXT) $(outbase).lib $(PATH_LIB)/; fi
-endif
 endif
 $(eval _DIRS += $(PATH_LIB))
@@ -332,12 +315,6 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
-ifdef KMK_USE_TEST
 	$(QUIET)$(TEST) -f $(out).manifest -- \
 		$(TOOL_VCC80X86_MT) -manifest $(subst /,\\,$(out)).manifest '-outputresource:$(subst /,\\,$(out));#2'
-else
-	$(QUIET)if test -f $(out).manifest; then \
-		$(TOOL_VCC80X86_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"; \
-	fi
-endif
-endef
-
+endef
+