Index: trunk/src/shell32/memorystream.cpp
===================================================================
--- trunk/src/shell32/memorystream.cpp	(revision 1396)
+++ trunk/src/shell32/memorystream.cpp	(revision 1398)
@@ -1,16 +1,30 @@
-/* $Id: memorystream.cpp,v 1.2 1999-10-09 11:17:00 sandervl Exp $ */
+/* $Id: memorystream.cpp,v 1.3 1999-10-22 12:18:46 phaller Exp $ */
+
 /*
- *	this class implements a pure IStream object
- *	and can be used for many purposes
+ * Win32 SHELL32 for OS/2
  *
- *	the main reason for implementing this was
- *	a cleaner implementation of IShellLink which
- *	needs to be able to load lnk's from a IStream
- *	interface so it was obvious to capsule the file
- *	access in a IStream to.
+ * Copyright 1999 Patrick Haller (haller@zebra.fh-weingarten.de)
+ * Project Odin Software License can be found in LICENSE.TXT
+ *
+ * this class implements a pure IStream object
+ * and can be used for many purposes
+ *
+ * the main reason for implementing this was
+ * a cleaner implementation of IShellLink which
+ * needs to be able to load lnk's from a IStream
+ * interface so it was obvious to capsule the file
+ * access in a IStream to.
  */
 
+
+/*****************************************************************************
+ * Includes                                                                  *
+ *****************************************************************************/
+
+#include <odin.h>
+#include <odinwrap.h>
+#include <os2sel.h>
+
 #include <string.h>
-#include <odin.h>
 
 #define ICOM_CINTERFACE 1
@@ -25,5 +39,11 @@
 #include <misc.h>
 
-DEFAULT_DEBUG_CHANNEL(shell)
+
+ODINDEBUGCHANNEL(SHELL32-MEMORYSTREAM)
+
+
+/*****************************************************************************
+ * Local Prototypes                                                          *
+ *****************************************************************************/
 
 static HRESULT WINAPI IStream_fnQueryInterface(IStream *iface, REFIID riid, LPVOID *ppvObj);
@@ -43,30 +63,30 @@
 
 static ICOM_VTABLE(IStream) stvt =
-{	
-	ICOM_MSVTABLE_COMPAT_DummyRTTIVALUE
-	IStream_fnQueryInterface,
-	IStream_fnAddRef,
-	IStream_fnRelease,
-	IStream_fnRead,
-	IStream_fnWrite,
-	IStream_fnSeek,
-	IStream_fnSetSize,
-	IStream_fnCopyTo,
-	IStream_fnCommit,
-	IStream_fnRevert,
-	IStream_fnLockRegion,
-	IStream_fnUnlockRegion,
-	IStream_fnStat,
-	IStream_fnClone
-	
+{
+   ICOM_MSVTABLE_COMPAT_DummyRTTIVALUE
+   IStream_fnQueryInterface,
+   IStream_fnAddRef,
+   IStream_fnRelease,
+   IStream_fnRead,
+   IStream_fnWrite,
+   IStream_fnSeek,
+   IStream_fnSetSize,
+   IStream_fnCopyTo,
+   IStream_fnCommit,
+   IStream_fnRevert,
+   IStream_fnLockRegion,
+   IStream_fnUnlockRegion,
+   IStream_fnStat,
+   IStream_fnClone
+
 };
 
 typedef struct
-{	ICOM_VTABLE(IStream)	*lpvtst;
-	DWORD		ref;
-	LPBYTE		pImage;
-	HANDLE		hMapping;
-	DWORD		dwLength;
-	DWORD		dwPos;
+{  ICOM_VTABLE(IStream)                  *lpvtst;
+   DWORD    ref;
+   LPBYTE      pImage;
+   HANDLE      hMapping;
+   DWORD    dwLength;
+   DWORD    dwPos;
 } ISHFileStream;
 
@@ -78,38 +98,42 @@
 HRESULT CreateStreamOnFile (LPCSTR pszFilename, IStream ** ppstm)
 {
-	ISHFileStream*	fstr;
-	OFSTRUCT	ofs;
-	HFILE		hFile = OpenFile( pszFilename, &ofs, OF_READ );
-	HRESULT		ret = E_FAIL;
-	
-	fstr = (ISHFileStream*)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,sizeof(ISHFileStream));
-	fstr->lpvtst=&stvt;
-	fstr->ref = 1;
-	fstr->dwLength = GetFileSize (hFile, NULL);
-
-	shell32_ObjCount++;
-
-	if (!(fstr->hMapping = CreateFileMappingA(hFile,NULL,PAGE_READONLY|SEC_COMMIT,0,0,NULL)))
-	{
-	  WARN("failed to create filemap.\n");
-	  goto end_2;
-	}
-
-	if (!(fstr->pImage = (BYTE*)MapViewOfFile(fstr->hMapping,FILE_MAP_READ,0,0,0)))
-	{
-	  WARN("failed to mmap filemap.\n");
-	  goto end_3;
-	}
-
-	ret = S_OK;
-	goto end_1;
-	
-end_3:	CloseHandle(fstr->hMapping);
-end_2:	HeapFree(GetProcessHeap(), 0, fstr);
-	fstr = NULL;
-
-end_1:	_lclose(hFile);
-	(*ppstm) = (IStream*)fstr;
-	return ret;
+   ISHFileStream* fstr;
+   OFSTRUCT ofs;
+   HFILE    hFile = OpenFile( pszFilename, &ofs, OF_READ );
+   HRESULT     ret = E_FAIL;
+
+   dprintf(("SHELL32:MemoryStream CreateStreamOnFile(%s,%08xh)\n",
+            pszFilename,
+            ppstm));
+
+   fstr = (ISHFileStream*)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,sizeof(ISHFileStream));
+   fstr->lpvtst=&stvt;
+   fstr->ref = 1;
+   fstr->dwLength = GetFileSize (hFile, NULL);
+
+   shell32_ObjCount++;
+
+   if (!(fstr->hMapping = CreateFileMappingA(hFile,NULL,PAGE_READONLY|SEC_COMMIT,0,0,NULL)))
+   {
+     dprintf(("failed to create filemap.\n"));
+     goto end_2;
+   }
+
+   if (!(fstr->pImage = (BYTE*)MapViewOfFile(fstr->hMapping,FILE_MAP_READ,0,0,0)))
+   {
+     dprintf(("failed to mmap filemap.\n"));
+     goto end_3;
+   }
+
+   ret = S_OK;
+   goto end_1;
+
+end_3:   CloseHandle(fstr->hMapping);
+end_2:   HeapFree(GetProcessHeap(), 0, fstr);
+   fstr = NULL;
+
+end_1:   _lclose(hFile);
+   (*ppstm) = (IStream*)fstr;
+   return ret;
 }
 
@@ -119,27 +143,28 @@
 static HRESULT WINAPI IStream_fnQueryInterface(IStream *iface, REFIID riid, LPVOID *ppvObj)
 {
-	ICOM_THIS(ISHFileStream, iface);
-
-	char    xriid[50];
-	WINE_StringFromCLSID((LPCLSID)riid,xriid);
-
-	TRACE("(%p)->(\n\tIID:\t%s,%p)\n",This,xriid,ppvObj);
-
-	*ppvObj = NULL;
-
-	if(IsEqualIID(riid, &IID_IUnknown) ||
-	   IsEqualIID(riid, &IID_IStream))
-	{
-	  *ppvObj = This;
-	}
-
-	if(*ppvObj)
-	{
-	  IStream_AddRef((IStream*)*ppvObj);
-	  TRACE("-- Interface: (%p)->(%p)\n",ppvObj,*ppvObj);
-	  return S_OK;
-	}
-	TRACE("-- Interface: E_NOINTERFACE\n");
-	return E_NOINTERFACE;
+   ICOM_THIS(ISHFileStream, iface);
+
+   char    xriid[50];
+   WINE_StringFromCLSID((LPCLSID)riid,xriid);
+
+   dprintf(("SHELL32:MemoryStream IStream_fnQueryInterface(%p)->(\n\tIID:\t%s,%p)\n",
+            This,xriid,ppvObj));
+
+   *ppvObj = NULL;
+
+   if(IsEqualIID(riid, &IID_IUnknown) ||
+      IsEqualIID(riid, &IID_IStream))
+   {
+     *ppvObj = This;
+   }
+
+   if(*ppvObj)
+   {
+     IStream_AddRef((IStream*)*ppvObj);
+     dprintf(("Interface: (%p)->(%p)\n",ppvObj,*ppvObj));
+     return S_OK;
+   }
+   dprintf(("-- Interface: E_NOINTERFACE\n"));
+   return E_NOINTERFACE;
 }
 
@@ -149,10 +174,11 @@
 static ULONG WINAPI IStream_fnAddRef(IStream *iface)
 {
-	ICOM_THIS(ISHFileStream, iface);
-
-	TRACE("(%p)->(count=%lu)\n",This, This->ref);
-
-	shell32_ObjCount++;
-	return ++(This->ref);
+   ICOM_THIS(ISHFileStream, iface);
+
+   dprintf(("SHELL32:MemoryStream IStream_fnAddRef (%p)->(count=%lu)\n",
+            This, This->ref));
+
+   shell32_ObjCount++;
+   return ++(This->ref);
 }
 
@@ -162,127 +188,129 @@
 static ULONG WINAPI IStream_fnRelease(IStream *iface)
 {
-	ICOM_THIS(ISHFileStream, iface);
-
-	TRACE("(%p)->()\n",This);
-
-	shell32_ObjCount--;
-
-	if (!--(This->ref))
-	{ TRACE(" destroying SHFileStream (%p)\n",This);
-
-	  UnmapViewOfFile(This->pImage);
-	  CloseHandle(This->hMapping);
-
-	  HeapFree(GetProcessHeap(),0,This);
-	  return 0;
-	}
-	return This->ref;
+   ICOM_THIS(ISHFileStream, iface);
+
+   dprintf(("SHELL32:MemoryStream IStream_fnRelease(%p)->()\n",
+            This));
+
+   shell32_ObjCount--;
+
+   if (!--(This->ref))
+   { dprintf((" destroying SHFileStream (%p)\n",This));
+
+     UnmapViewOfFile(This->pImage);
+     CloseHandle(This->hMapping);
+
+     HeapFree(GetProcessHeap(),0,This);
+     return 0;
+   }
+   return This->ref;
 }
 
 static HRESULT WINAPI IStream_fnRead (IStream * iface, void* pv, ULONG cb, ULONG* pcbRead)
 {
-	ICOM_THIS(ISHFileStream, iface);
-
-	DWORD dwBytesToRead, dwBytesLeft;
-	
-	TRACE("(%p)->(%p,0x%08lx,%p)\n",This, pv, cb, pcbRead);
-	
-	if ( !pv )
-	  return STG_E_INVALIDPOINTER;
-
-	dwBytesLeft = This->dwLength - This->dwPos;
-
-	if ( 0 >= dwBytesLeft )						/* end of buffer */
-	  return S_FALSE;
-	
-	dwBytesToRead = ( cb > dwBytesLeft) ? dwBytesLeft : cb;
-
-	memmove ( pv, (This->pImage) + (This->dwPos), dwBytesToRead);
-	
-	This->dwPos += dwBytesToRead;					/* adjust pointer */
-
-	if (pcbRead)
-	  *pcbRead = dwBytesToRead;
-
-	return S_OK;
+   DWORD dwBytesToRead, dwBytesLeft;
+
+   ICOM_THIS(ISHFileStream, iface);
+
+   dprintf(("SHELL32:MemoryStream IStream_fnRead(%p)->(%p,%p,%p)\n",
+            This, pv, cb, pcbRead));
+
+   if ( !pv )
+     return STG_E_INVALIDPOINTER;
+
+   dwBytesLeft = This->dwLength - This->dwPos;
+
+   if ( 0 >= dwBytesLeft )                              /* end of buffer */
+     return S_FALSE;
+
+   dwBytesToRead = ( cb > dwBytesLeft) ? dwBytesLeft : cb;
+
+   memmove ( pv, (This->pImage) + (This->dwPos), dwBytesToRead);
+
+   This->dwPos += dwBytesToRead;                     /* adjust pointer */
+
+   if (pcbRead)
+     *pcbRead = dwBytesToRead;
+
+   return S_OK;
 }
 static HRESULT WINAPI IStream_fnWrite (IStream * iface, const void* pv, ULONG cb, ULONG* pcbWritten)
 {
-	ICOM_THIS(ISHFileStream, iface);
-
-	TRACE("(%p)\n",This);
-
-	return E_NOTIMPL;
+   ICOM_THIS(ISHFileStream, iface);
+
+   dprintf(("SHELL32:MemoryStream IStream_fnWrite (%p) not implemented\n",This));
+
+   return E_NOTIMPL;
 }
 static HRESULT WINAPI IStream_fnSeek (IStream * iface, LARGE_INTEGER dlibMove, DWORD dwOrigin, ULARGE_INTEGER* plibNewPosition)
 {
-	ICOM_THIS(ISHFileStream, iface);
-
-	TRACE("(%p)\n",This);
-
-	return E_NOTIMPL;
+   ICOM_THIS(ISHFileStream, iface);
+
+   dprintf(("SHELL32:MemoryStream IStream_fnSeek (%p) not implemented\n",This));
+
+   return E_NOTIMPL;
 }
 static HRESULT WINAPI IStream_fnSetSize (IStream * iface, ULARGE_INTEGER libNewSize)
 {
-	ICOM_THIS(ISHFileStream, iface);
-
-	TRACE("(%p)\n",This);
-
-	return E_NOTIMPL;
+   ICOM_THIS(ISHFileStream, iface);
+
+   dprintf(("SHELL32:MemoryStream IStream_fnSetSize (%p) not implemented\n",This));
+
+   return E_NOTIMPL;
 }
 static HRESULT WINAPI IStream_fnCopyTo (IStream * iface, IStream* pstm, ULARGE_INTEGER cb, ULARGE_INTEGER* pcbRead, ULARGE_INTEGER* pcbWritten)
 {
-	ICOM_THIS(ISHFileStream, iface);
-
-	TRACE("(%p)\n",This);
-
-	return E_NOTIMPL;
+   ICOM_THIS(ISHFileStream, iface);
+
+   dprintf(("SHELL32:MemoryStream IStream_fnCopyTo (%p) not implemented\n",This));
+
+   return E_NOTIMPL;
 }
 static HRESULT WINAPI IStream_fnCommit (IStream * iface, DWORD grfCommitFlags)
 {
-	ICOM_THIS(ISHFileStream, iface);
-
-	TRACE("(%p)\n",This);
-
-	return E_NOTIMPL;
+   ICOM_THIS(ISHFileStream, iface);
+
+   dprintf(("SHELL32:MemoryStream IStream_fnCommit (%p) not implemented\n",This));
+
+   return E_NOTIMPL;
 }
 static HRESULT WINAPI IStream_fnRevert (IStream * iface)
 {
-	ICOM_THIS(ISHFileStream, iface);
-
-	TRACE("(%p)\n",This);
-
-	return E_NOTIMPL;
+   ICOM_THIS(ISHFileStream, iface);
+
+   dprintf(("SHELL32:MemoryStream IStream_fnRevert (%p) not implemented\n",This));
+
+   return E_NOTIMPL;
 }
 static HRESULT WINAPI IStream_fnLockRegion (IStream * iface, ULARGE_INTEGER libOffset, ULARGE_INTEGER cb, DWORD dwLockType)
 {
-	ICOM_THIS(ISHFileStream, iface);
-
-	TRACE("(%p)\n",This);
-
-	return E_NOTIMPL;
+   ICOM_THIS(ISHFileStream, iface);
+
+   dprintf(("SHELL32:MemoryStream IStream_fnLockRegion (%p) not implemented\n",This));
+
+   return E_NOTIMPL;
 }
 static HRESULT WINAPI IStream_fnUnlockRegion (IStream * iface, ULARGE_INTEGER libOffset, ULARGE_INTEGER cb, DWORD dwLockType)
 {
-	ICOM_THIS(ISHFileStream, iface);
-
-	TRACE("(%p)\n",This);
-
-	return E_NOTIMPL;
+   ICOM_THIS(ISHFileStream, iface);
+
+   dprintf(("SHELL32:MemoryStream IStream_fnUnlockRegoin (%p) not implemented.\n",This));
+
+   return E_NOTIMPL;
 }
 static HRESULT WINAPI IStream_fnStat (IStream * iface, STATSTG*   pstatstg, DWORD grfStatFlag)
 {
-	ICOM_THIS(ISHFileStream, iface);
-
-	TRACE("(%p)\n",This);
-
-	return E_NOTIMPL;
+   ICOM_THIS(ISHFileStream, iface);
+
+   dprintf(("SHELL32:MemoryStream IStream_fnStat (%p) not implemented.\n",This));
+
+   return E_NOTIMPL;
 }
 static HRESULT WINAPI IStream_fnClone (IStream * iface, IStream** ppstm)
 {
-	ICOM_THIS(ISHFileStream, iface);
-
-	TRACE("(%p)\n",This);
-
-	return E_NOTIMPL;
-}
+   ICOM_THIS(ISHFileStream, iface);
+
+   dprintf(("SHELL32:MemoryStream IStream_fnClone (%p) not implemented.\n",This));
+
+   return E_NOTIMPL;
+}
Index: trunk/src/shell32/resource.asm
===================================================================
--- trunk/src/shell32/resource.asm	(revision 1396)
+++ trunk/src/shell32/resource.asm	(revision 1398)
@@ -1,6 +1,6 @@
 ;/* This file is generated with wrc version 1.0.14 (08-Aug-1999). Do not edit! */
 ;/* Source : shres.rc */
-;/* Cmdline: wrc -s -I. -If:\ibmcpp\include -I..\..\include -I..\..\include\win -o resource.asm shres.rc */
-;/* Date   : Mon Oct 11 22:08:04 1999 */
+;/* Cmdline: wrc -s -I. -ID:\IBMCPP\include -I..\..\include -I..\..\include\win -o resource.asm shres.rc */
+;/* Date   : Tue Oct 19 20:15:43 1999 */
 
 	.386p
@@ -12,5 +12,5 @@
 	public	_Resource_PEResTab
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 6
@@ -29,5 +29,5 @@
 L3:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 16
@@ -66,25 +66,25 @@
 L4:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	3, 0
-	dd	(_Resource_MENU_001_name - _Resource_PEResTab) or 80000000h
+	dd	(_Resource_4_MENU_001_name - _Resource_PEResTab) or 80000000h
 	dd	(L4_MENU_001 - _Resource_PEResTab) or 80000000h
-	dd	(_Resource_MENU_002_name - _Resource_PEResTab) or 80000000h
+	dd	(_Resource_4_MENU_002_name - _Resource_PEResTab) or 80000000h
 	dd	(L4_MENU_002 - _Resource_PEResTab) or 80000000h
-	dd	(_Resource_MENU_SHV_FILE_name - _Resource_PEResTab) or 80000000h
+	dd	(_Resource_4_MENU_SHV_FILE_name - _Resource_PEResTab) or 80000000h
 	dd	(L4_MENU_SHV_FILE - _Resource_PEResTab) or 80000000h
 L5:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	2, 0
-	dd	(_Resource_SHBRSFORFOLDER_MSGBOX_name - _Resource_PEResTab) or 80000000h
+	dd	(_Resource_5_SHBRSFORFOLDER_MSGBOX_name - _Resource_PEResTab) or 80000000h
 	dd	(L5_SHBRSFORFOLDER_MSGBOX - _Resource_PEResTab) or 80000000h
-	dd	(_Resource_SHELL_ABOUT_MSGBOX_name - _Resource_PEResTab) or 80000000h
+	dd	(_Resource_5_SHELL_ABOUT_MSGBOX_name - _Resource_PEResTab) or 80000000h
 	dd	(L5_SHELL_ABOUT_MSGBOX - _Resource_PEResTab) or 80000000h
 L6:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 2
@@ -95,5 +95,5 @@
 L14:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 5
@@ -110,5 +110,5 @@
 L16:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -117,5 +117,5 @@
 L3_1:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -124,5 +124,5 @@
 L3_2:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -131,5 +131,5 @@
 L3_3:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -138,5 +138,5 @@
 L3_4:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -145,5 +145,5 @@
 L3_5:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -152,5 +152,5 @@
 L3_6:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -159,5 +159,5 @@
 L3_7:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -166,5 +166,5 @@
 L3_8:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -173,5 +173,5 @@
 L3_9:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -180,5 +180,5 @@
 L3_10:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -187,5 +187,5 @@
 L3_11:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -194,5 +194,5 @@
 L3_12:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -201,5 +201,5 @@
 L3_13:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -208,5 +208,5 @@
 L3_14:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -215,5 +215,5 @@
 L3_15:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -222,5 +222,5 @@
 L3_16:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -229,5 +229,5 @@
 L4_MENU_001:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -236,5 +236,5 @@
 L4_MENU_002:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -243,5 +243,5 @@
 L4_MENU_SHV_FILE:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -250,5 +250,5 @@
 L5_SHBRSFORFOLDER_MSGBOX:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -257,5 +257,5 @@
 L5_SHELL_ABOUT_MSGBOX:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -264,5 +264,5 @@
 L6_1:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -271,5 +271,5 @@
 L6_2:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -278,5 +278,5 @@
 L14_0:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -285,5 +285,5 @@
 L14_3:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -292,5 +292,5 @@
 L14_8:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -299,5 +299,5 @@
 L14_15:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -306,5 +306,5 @@
 L14_34:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -313,5 +313,5 @@
 L16_1:
 	dd	0
-	dd	0380243a4h
+	dd	0380cc35fh
 	dd	0
 	dw	0, 1
@@ -465,18 +465,18 @@
 	dd	0
 	dd	0
-_Resource_MENU_001_name:
+_Resource_4_MENU_001_name:
 	db	008h, 000h, 04dh, 000h, 045h, 000h, 04eh, 000h
 	db	055h, 000h, 05fh, 000h, 030h, 000h, 030h, 000h
 	db	031h, 000h
-_Resource_MENU_002_name:
+_Resource_4_MENU_002_name:
 	db	008h, 000h, 04dh, 000h, 045h, 000h, 04eh, 000h
 	db	055h, 000h, 05fh, 000h, 030h, 000h, 030h, 000h
 	db	032h, 000h
-_Resource_MENU_SHV_FILE_name:
+_Resource_4_MENU_SHV_FILE_name:
 	db	00dh, 000h, 04dh, 000h, 045h, 000h, 04eh, 000h
 	db	055h, 000h, 05fh, 000h, 053h, 000h, 048h, 000h
 	db	056h, 000h, 05fh, 000h, 046h, 000h, 049h, 000h
 	db	04ch, 000h, 045h, 000h
-_Resource_SHBRSFORFOLDER_MSGBOX_name:
+_Resource_5_SHBRSFORFOLDER_MSGBOX_name:
 	db	015h, 000h, 053h, 000h, 048h, 000h, 042h, 000h
 	db	052h, 000h, 053h, 000h, 046h, 000h, 04fh, 000h
@@ -485,5 +485,5 @@
 	db	04dh, 000h, 053h, 000h, 047h, 000h, 042h, 000h
 	db	04fh, 000h, 058h, 000h
-_Resource_SHELL_ABOUT_MSGBOX_name:
+_Resource_5_SHELL_ABOUT_MSGBOX_name:
 	db	012h, 000h, 053h, 000h, 048h, 000h, 045h, 000h
 	db	04ch, 000h, 04ch, 000h, 05fh, 000h, 041h, 000h